/*
 *	DNETREK.C
 *
 *	DNET (c)Copyright 1988, Matthew Dillon, All Rights Reserved
 *      server (c)Copyright 1991, Todd Williamson
 *      revisions for 2.0 (c)Copyright 1993, ERic Mehlhaff
 *
 *	Connects Amiga netrek client with netrek server.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <errno.h>
#include <signal.h>


#ifndef PORT_DNNTP
#define PORT_DNNTP 8119
#endif
#define BLEN 2048
#define TRUE 1

int total=0;

int pfd, fd, s= -1;

extern int errno; 
void handler(), chandler();

unsigned char buf2[BLEN];

int totalconnects=0;

main(ac,av)
char *av[];
{
    long chann;
    fd_set              rfd;
    struct timeval      to;
    struct sockaddr_in  from;

    printf("Starting DListen(%d)\n", PORT_DNNTP);
    chann = DListen(PORT_DNNTP);
    printf("DListen done.\n");
    signal(SIGCHLD, chandler);
    signal(SIGPIPE, SIG_IGN);
    for(;;) {
      pfd = DAccept(chann);
      printf("DAccept completed: fd: %d\n", pfd);
      if(pfd <0){
	if(totalconnects<=0) {
	  printf("No more connections from Amiga, exiting.\n");
	  /*exit(0);*/
	}
	if(errno==EINTR)
	  continue;
	perror("DAccept error");
	exit(1);
      }
      totalconnects++;
	
      if(fork()==NULL) {
	fd=dup(pfd);
	DoNNTP(fd);
	close(fd);
	exit(0);
      }
    }
}

DoNNTP(int fd)
{
  int port, s;
  char *hostname;
  struct sockaddr_in addr;
  struct hostent *hp;

  hostname= getenv("NNTPSERVER");
  if(!hostname) {
    printf("$NNTPSERVER not set, using \"news\"\n");
    hostname="news";
  }
  port = 119;

  printf("Connecting to %s\n",hostname);

  if ((s=socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    printf("I can't create a socket\n");
    exit(0);
  }
  addr.sin_family = AF_INET;
  addr.sin_port = htons(port);
	
  if ((addr.sin_addr.s_addr = inet_addr(hostname)) == -1) {
    if ((hp = gethostbyname(hostname)) == NULL) {
      printf("Who is %s?\n", hostname);
      gwrite(fd, "Who is?", 7);
      exit(0);
    } else {
      addr.sin_addr.s_addr = *(long *) hp->h_addr;
    }
  }
	    
  if (connect(s, &addr, sizeof(addr)) < 0) {
    printf("Server not listening!\n");
    exit(0);
  }

  ioloop(s,fd);

  printf("ioloop done, exiting!\n");

  close(fd);
  shutdown(s,2);
  close(s);
  exit(0);
}

ioloop(int s,int fd)
{
  int Done=0, bytesread, byteswritten;
  char buf1[BLEN], buf2[BLEN], *chk;
  fd_set rd;
  int got_period=0;

  /* strip announcement line(s?) */
  while(!got_period) {
    FD_ZERO(&rd);
    FD_SET(s,&rd);
    select(32,&rd,0,0,0);
    if(FD_ISSET(s, &rd)) {
      if((bytesread=read(s, buf1, BLEN))>0) {
	for(chk=&buf1[bytesread-1];
	    isspace(*chk) && chk>buf1;
	    chk--)
	  ;
	if(*chk == '.')
	  got_period=1;
      }
    }
  } 
  while (!Done) {
    FD_ZERO(&rd);	/* Clear Bit Flag Field */
    FD_SET(s, &rd);	/* servfd = socket descriptor */
    FD_SET(fd, &rd);	/* chan = dnet descriptor */
    
    /* Now Wait for Input from either DNET or UNIX SOCKET */
    
    switch (select(32, &rd, 0, 0, 0)) { /* wait here */
    case -1:
    case 0:
      break;
      
    default:
      /* Check for data from Amiga client */
      
      if (FD_ISSET(fd, &rd)) {
	if ((bytesread = read(fd, buf1, BLEN))>0) {
	  byteswritten = write(s, buf1, bytesread);
	  byteswritten = write(fd, buf1, bytesread);
	  if (byteswritten != bytesread)
	    Done = TRUE;
	} else
	  Done=TRUE;

      }
      /* Check for data from internet host */
      if (FD_ISSET(s, &rd)) { /* if input from SOCKET */
	if ((bytesread = read(s, buf2, BLEN))>0) {
	  byteswritten = write(fd, buf2, bytesread);
	  if (byteswritten != bytesread)
	    Done = TRUE;
	} else
	  Done = TRUE;
      }
      break;
    } /* End of Switch */
  } /* End of While */
}    

void chandler()
{
    union wait stat;
    struct rusage rus;
    while (wait3(&stat, WNOHANG, &rus) > 0);
    totalconnects--;
}

#if 0
void handler()
{
    int n, m, i;
    
    while((n = read(s, buf2, BLEN)) > 0) {
	total += n;
	while((i = gwrite(fd, buf2, n)) < 0) {
	    m = 1<<fd;
	    select(32, 0, &m, 0, 0);
	}
    }
    if(n == 0) {
	close(fd);
	shutdown(s,2);
	close(s);
	printf("EOF from server\n");
	exit(0);
    }
}
#endif
